Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExpressionFactory.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExpressionFactory.cs	(revision 14328)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ExpressionFactory.cs	(revision 14328)
@@ -0,0 +1,95 @@
+﻿using System;
+using System.Collections.Generic;
+using HeuristicLab.Algorithms.PushGP.Expressions.Boolean;
+using HeuristicLab.Algorithms.PushGP.Expressions.Code;
+using HeuristicLab.Algorithms.PushGP.Expressions.Exec;
+using HeuristicLab.Algorithms.PushGP.Expressions.Float;
+using HeuristicLab.Algorithms.PushGP.Expressions.Integer;
+using HeuristicLab.Algorithms.PushGP.Expressions.Templates;
+using HeuristicLab.Algorithms.PushGP.Interpreter;
+using HeuristicLab.Algorithms.PushGP.Stack;
+
+namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+    public static class ExpressionFactory
+    {
+        private static Func<IInterpreter, IStack<Expression>> execStackProvider = interpreter => interpreter.ExecStack;
+        private static Func<IInterpreter, IStack<Expression>> codeStackProvider = interpreter => interpreter.CodeStack;
+        private static Func<IInterpreter, IStack<string>> nameStackProvider = interpreter => interpreter.NameStack;
+        private static Func<IInterpreter, IStack<long>> integerStackProvider = interpreter => interpreter.IntegerStack;
+        private static Func<IInterpreter, IStack<double>> floatStackProvider = interpreter => interpreter.FloatStack;
+        private static Func<IInterpreter, IStack<bool>> booleanStackProvider = interpreter => interpreter.BooleanStack;
+
+        private static IDictionary<OpCode, Expression> expressions = new Dictionary<OpCode, Expression>()
+        {
+            #region Exec
+            { OpCode.ExecPop, new PopExpressionTemplate<Expression>(Symbols.ExecPop, execStackProvider) },
+            { OpCode.ExecDuplicate, new DuplicateExpressionTemplate<Expression>(Symbols.ExecDuplicate, execStackProvider) },
+            { OpCode.ExecDefine, new ExecDefineExpression() },
+            { OpCode.ExecDoXRange, new ExecDoRangeExpression() },
+            { OpCode.ExecY, new ExecYExpression() },
+            { OpCode.ExecIf, new ExecIfExpression() },
+            #endregion Exec
+
+            #region Code
+            { OpCode.CodeDuplicate, new DuplicateExpressionTemplate<Expression>(Symbols.CodeDuplicate, codeStackProvider, true) },
+            { OpCode.CodeDefine, new CodeDefineExpression() },
+            { OpCode.CodeQuote, new CodeQuoteExpression() },
+            { OpCode.CodeDo, new CodeDoExpression() },
+            { OpCode.CodeIf, new CodeIfExpression() },
+            { OpCode.CodeNoop, new CodeNoopExpression() },
+            #endregion Code
+
+            #region Name
+            { OpCode.NamePop, new PopExpressionTemplate<string>(Symbols.NamePop, nameStackProvider) },
+            { OpCode.NameDuplicate, new DuplicateExpressionTemplate<string>(Symbols.NameDuplicate, nameStackProvider) },
+            #endregion Name
+
+            #region Boolean
+            { OpCode.BooleanPop, new PopExpressionTemplate<bool>(Symbols.BooleanPop, booleanStackProvider) },
+            { OpCode.BooleanDuplicate, new DuplicateExpressionTemplate<bool>(Symbols.BooleanDuplicate, booleanStackProvider) },
+            { OpCode.BooleanDefine, new DefineExpressionTemplate<bool>(Symbols.BooleanDefine, booleanStackProvider, v => new BooleanPushExpression(v)) },
+            { OpCode.BooleanOr, new PushResultExpressionTemplate<bool, bool>(Symbols.BooleanOr, booleanStackProvider, booleanStackProvider, v => v[0] || v[1]) },
+            { OpCode.BooleanAnd, new PushResultExpressionTemplate<bool, bool>(Symbols.BooleanAnd, booleanStackProvider, booleanStackProvider, v => v[0] && v[1]) },
+            #endregion Boolean
+
+            #region Float
+            { OpCode.IntegerPop, new PopExpressionTemplate<long>(Symbols.IntegerPop, integerStackProvider) },
+            { OpCode.IntegerDuplicate, new DuplicateExpressionTemplate<long>(Symbols.IntegerDuplicate, integerStackProvider) },
+            { OpCode.IntegerDefine, new DefineExpressionTemplate<long>(Symbols.IntegerDefine, integerStackProvider, v => new IntegerPushExpression(v)) },
+            { OpCode.IntegerAdd, new PushResultExpressionTemplate<long, long>(Symbols.IntegerAdd, integerStackProvider, integerStackProvider, v => v[0] + v[1]) },
+            { OpCode.IntegerSubtract, new PushResultExpressionTemplate<long, long>(Symbols.IntegerSubtract, integerStackProvider, integerStackProvider, v => v[0] - v[1]) },
+            { OpCode.IntegerMultiply, new PushResultExpressionTemplate<long, long>(Symbols.IntegerMultiply, integerStackProvider, integerStackProvider, v => v[0] * v[1]) },
+            { OpCode.IntegerDivide, new PushResultExpressionTemplate<long, long>(Symbols.IntegerDivide, integerStackProvider, integerStackProvider, v => v[0] / v[1]) },
+            { OpCode.IntegerMin, new PushResultExpressionTemplate<long, long>(Symbols.IntegerMin, integerStackProvider, integerStackProvider, v => Math.Min(v[0], v[1])) },
+            { OpCode.IntegerMax, new PushResultExpressionTemplate<long, long>(Symbols.IntegerMax, integerStackProvider, integerStackProvider, v => Math.Max(v[0], v[1])) },
+            { OpCode.IntegerSmallerThan, new PushResultExpressionTemplate<long, bool>(Symbols.IntegerSmallerThan, integerStackProvider, booleanStackProvider, v => v[0] < v[1]) },
+            { OpCode.IntegerGreaterThan, new PushResultExpressionTemplate<long, bool>(Symbols.IntegerGreaterThan, integerStackProvider, booleanStackProvider, v => v[0] > v[1]) },
+            { OpCode.IntegerEquals, new PushResultExpressionTemplate<long, bool>(Symbols.IntegerEquals, integerStackProvider, booleanStackProvider, v => v[0] == v[1]) },
+            #endregion Float
+
+            #region Float
+            { OpCode.FloatPop, new PopExpressionTemplate<double>(Symbols.FloatPop, floatStackProvider) },
+            { OpCode.FloatDuplicate, new DuplicateExpressionTemplate<double>(Symbols.FloatDuplicate, floatStackProvider) },
+            { OpCode.FloatDefine, new DefineExpressionTemplate<double>(Symbols.FloatDefine, floatStackProvider, v => new FloatPushExpression(v)) },
+            { OpCode.FloatAdd, new PushResultExpressionTemplate<double, double>(Symbols.FloatAdd, floatStackProvider, floatStackProvider, v => v[0] + v[1]) },
+            { OpCode.FloatSubtract, new PushResultExpressionTemplate<double, double>(Symbols.FloatSubtract, floatStackProvider, floatStackProvider, v => v[0] - v[1]) },
+            { OpCode.FloatMultiply, new PushResultExpressionTemplate<double, double>(Symbols.FloatMultiply, floatStackProvider, floatStackProvider, v => v[0] * v[1]) },
+            { OpCode.FloatDivide, new PushResultExpressionTemplate<double, double>(Symbols.FloatDivide, floatStackProvider, floatStackProvider, v => v[0] / v[1]) },
+            { OpCode.FloatMin, new PushResultExpressionTemplate<double, double>(Symbols.FloatMin, floatStackProvider, floatStackProvider, v => Math.Min(v[0], v[1])) },
+            { OpCode.FloatMax, new PushResultExpressionTemplate<double, double>(Symbols.FloatMax, floatStackProvider, floatStackProvider, v => Math.Max(v[0], v[1])) },
+            { OpCode.FloatSmallerThan, new PushResultExpressionTemplate<double, bool>(Symbols.FloatSmallerThan, floatStackProvider, booleanStackProvider, v => v[0] < v[1]) },
+            { OpCode.FloatGreaterThan, new PushResultExpressionTemplate<double, bool>(Symbols.FloatGreaterThan, floatStackProvider, booleanStackProvider, v => v[0] > v[1]) },
+            { OpCode.FloatEquals, new PushResultExpressionTemplate<double, bool>(Symbols.FloatEquals, floatStackProvider, booleanStackProvider, v => v[0] == v[1]) },
+            #endregion Float
+        };
+
+        public static Expression Create(OpCode opCode)
+        {
+            Expression expression;
+            return expressions.TryGetValue(opCode, out expression)
+                ? expression
+                : expressions[OpCode.CodeNoop];
+        }
+    }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Float/FloatPushExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Float/FloatPushExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Float/FloatPushExpression.cs	(revision 14328)
@@ -1,23 +1,24 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Float
 {
     public class FloatPushExpression : Expression
     {
-        public FloatPushExpression(double value) : base(OpCode.FloatPush)
+        private readonly double value;
+        public FloatPushExpression(double value)
         {
-            this.Value = value;
+            this.value = value;
         }
 
-        public double Value { get; }
+        public override bool IsCodeOp { get { return false; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
-            interpreterService.FloatStack.Push(Value);
+            interpreter.FloatStack.Push(this.value);
         }
 
         public override string ToString()
         {
-            return $"{this.Value}";
+            return this.value.ToString();
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Integer/IntegerPushExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Integer/IntegerPushExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Integer/IntegerPushExpression.cs	(revision 14328)
@@ -1,23 +1,24 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Integer
 {
     public class IntegerPushExpression : Expression
     {
-        public IntegerPushExpression(long value) : base(OpCode.IntegerPush)
+        private readonly long value;
+        public IntegerPushExpression(long value)
         {
-            this.Value = value;
+            this.value = value;
         }
 
-        public long Value { get; }
+        public override bool IsCodeOp { get { return false; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
-            interpreterService.IntegerStack.Push(Value);
+            interpreter.IntegerStack.Push(this.value);
         }
 
         public override string ToString()
         {
-            return $"{this.Value}";
+            return this.value.ToString();
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Name/NameDefineXExecExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Name/NameDefineXExecExpression.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/Name/NameDefineXExecExpression.cs	(revision 14328)
@@ -1,25 +1,26 @@
-﻿using HeuristicLab.Algorithms.PushGP.Stack;
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
+namespace HeuristicLab.Algorithms.PushGP.Expressions.Name
 {
     public class NameDefineXExecExpression : Expression
     {
-        public NameDefineXExecExpression(string value) : base(OpCode.NameDefineXExec)
+        private readonly string name;
+        public NameDefineXExecExpression(string name)
         {
-            this.Value = value;
+            this.name = name;
         }
 
-        public string Value { get; }
+        public override bool IsCodeOp { get { return false; } }
 
-        public override void Eval(IInterpreterService interpreterService)
+        public override void Eval(IInterpreter interpreter)
         {
             Expression expression;
-            if (interpreterService.CustomExpressions.TryGetValue(this.Value, out expression))
+            if (interpreter.CustomExpressions.TryGetValue(this.name, out expression))
             {
-                interpreterService.ExecStack.Push(expression);
+                interpreter.ExecStack.Push(expression);
             }
             else
             {
-                interpreterService.NameStack.Push(this.Value);
+                interpreter.NameStack.Push(this.name);
             }
         }
@@ -27,5 +28,5 @@
         public override string ToString()
         {
-            return this.Value;
+            return this.name;
         }
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/CodeGenerator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/CodeGenerator.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/CodeGenerator.cs	(revision 14328)
@@ -1,6 +1,6 @@
-﻿using System;
-using System.Collections.Generic;
+﻿using System.Collections.Generic;
 using System.Linq;
 using HeuristicLab.Algorithms.PushGP.Expressions;
+using HeuristicLab.Random;
 
 namespace HeuristicLab.Algorithms.PushGP.Generators
@@ -8,7 +8,8 @@
     public static class CodeGenerator
     {
+        private static FastRandom random = new FastRandom();
         public static IEnumerable<Expression> RandomCode(int maxPoints)
         {
-            var actualPoints = StaticRandom.Next(1, maxPoints);
+            var actualPoints = random.Next(1, maxPoints);
 
             return RandomCodeWithSize(actualPoints).ToArray();
@@ -19,15 +20,8 @@
             if (points == 1)
             {
-                OpCode opCode;
-                Func<Expression> creator;
+                // TODO: If this is an "ephemeral random constant"???? then return a randomly - chosen value of the appropriate type;
+                var opCode = (OpCode)random.Next(OpCodeExtensions.Min, OpCodeExtensions.Max);
 
-                do
-                {
-                    // TODO: If this is an "ephemeral random constant"???? then return a randomly - chosen value of the appropriate type;
-                    opCode = (OpCode)StaticRandom.Next(OpCodeExtensions.Min, OpCodeExtensions.Max);
-                }
-                while (!ExpressionCreatorTable.TryGetCreator(opCode, out creator));
-
-                return new[] { creator.Invoke() };
+                return new[] { ExpressionFactory.Create(opCode) };
             }
             else
@@ -35,5 +29,5 @@
                 var sizesThisLevel = Decompose(points - 1, points - 1);
 
-                return sizesThisLevel.SelectMany(size => RandomCodeWithSize(size));
+                return sizesThisLevel.SelectMany(size => RandomCodeWithSize(size)).Shuffle(random);
             }
         }
@@ -47,5 +41,5 @@
             else
             {
-                var thisPart = StaticRandom.Next(1, number - 1);
+                var thisPart = random.Next(1, number - 1);
 
                 return new[] { thisPart }.Concat(Decompose(number - thisPart, maxParts - 1));
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/Configuration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/Configuration.cs	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/Configuration.cs	(revision 14328)
@@ -3,23 +3,32 @@
     public class Configuration
     {
+        public Configuration()
+        {
+            this.MinRandomInteger = long.MinValue;
+            this.MaxRandomInteger = long.MaxValue;
+            this.MinRandomFloat = double.MaxValue;
+            this.MaxRandomFloat = double.MaxValue;
+            this.NewErcNameProbability = 0.5;
+        }
+
         /// <summary>
         /// The minimum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
         /// </summary>
-        public long MinRandomInteger { get; set; } = long.MinValue;
+        public long MinRandomInteger { get; set; }
 
         /// <summary>
         /// The maximum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
         /// </summary>
-        public long MaxRandomInteger { get; set; } = long.MaxValue;
+        public long MaxRandomInteger { get; set; }
 
         /// <summary>
         /// The minimum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
         /// </summary>
-        public double MinRandomFloag { get; set; } = double.MinValue;
+        public double MinRandomFloat { get; set; }
 
         /// <summary>
         /// The maximum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
         /// </summary>
-        public double MaxRandomFloag { get; set; } = double.MaxValue;
+        public double MaxRandomFloat { get; set; }
 
         /// <summary>
@@ -28,5 +37,5 @@
         /// (rather than a name that was previously generated).
         /// </summary>
-        public double NewErcNameProbability { get; set; } = 0.5;
+        public double NewErcNameProbability { get; set; }
     }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj	(revision 14327)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj	(revision 14328)
@@ -10,6 +10,7 @@
     <RootNamespace>HeuristicLab.Algorithms.PushGP</RootNamespace>
     <AssemblyName>HeuristicLab.Algorithms.PushGP</AssemblyName>
-    <TargetFrameworkVersion>v4.5.2</TargetFrameworkVersion>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
+    <TargetFrameworkProfile />
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
@@ -29,6 +30,16 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <LangVersion>5</LangVersion>
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Common-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Core-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Random-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Random-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core" />
@@ -41,79 +52,40 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Interpreter\Configuration.cs" />
-    <Compile Include="Data\Expression.cs" />
-    <Compile Include="Expressions\Boolean\BooleanAndExpression.cs" />
-    <Compile Include="Expressions\Boolean\BooleanOrExpression.cs" />
+    <Compile Include="Exporter\Exporter.cs" />
     <Compile Include="Expressions\Boolean\BooleanPushExpression.cs" />
-    <Compile Include="Expressions\Boolean\BooleanDuplicateExpression.cs" />
-    <Compile Include="Expressions\Boolean\BooleanDefineExpression.cs" />
-    <Compile Include="Expressions\Boolean\BooleanPopExpression.cs" />
-    <Compile Include="Expressions\Exec\ExecIfExpression.cs" />
+    <Compile Include="Expressions\Code\CodeDoExpression.cs" />
+    <Compile Include="Expressions\Code\CodeDefineExpression.cs" />
     <Compile Include="Expressions\Code\CodeIfExpression.cs" />
-    <Compile Include="Expressions\Code\CodeDoExpression.cs" />
+    <Compile Include="Expressions\Code\CodeNoopExpression.cs" />
     <Compile Include="Expressions\Code\CodeQuoteExpression.cs" />
-    <Compile Include="Expressions\Code\CodeDuplicateExpression.cs" />
-    <Compile Include="Expressions\Code\CodeNoopExpression.cs" />
-    <Compile Include="Expressions\Code\CodePushExpression.cs" />
-    <Compile Include="Expressions\Code\CodeDefineExpression.cs" />
+    <Compile Include="Expressions\Exec\ExecDefineExpression.cs" />
     <Compile Include="Expressions\Exec\ExecYExpression.cs" />
     <Compile Include="Expressions\Exec\ExecDoRangeExpression.cs" />
-    <Compile Include="Expressions\Exec\ExecDuplicateExpression.cs" />
+    <Compile Include="Expressions\Exec\ExecIfExpression.cs" />
+    <Compile Include="Expressions\Exec\ExecPushExpression.cs" />
     <Compile Include="Expressions\Exec\ExecExpandExpression.cs" />
-    <Compile Include="Expressions\Exec\ExecPushExpression.cs" />
-    <Compile Include="Expressions\Exec\ExecDefineExpression.cs" />
-    <Compile Include="Expressions\Exec\ExecPopExpression.cs" />
+    <Compile Include="Expressions\ExpressionFactory.cs" />
     <Compile Include="Expressions\Expression.cs" />
-    <Compile Include="ExpressionCreatorTable.cs" />
-    <Compile Include="Expressions\Float\FloatAddExpression.cs" />
     <Compile Include="Expressions\Float\FloatPushExpression.cs" />
-    <Compile Include="Expressions\Float\FloatMultiplyExpression.cs" />
-    <Compile Include="Expressions\Float\FloatDivideExpression.cs" />
-    <Compile Include="Expressions\Float\FloatSubtractExpression.cs" />
-    <Compile Include="Expressions\Float\FloatDuplicateExpression.cs" />
-    <Compile Include="Expressions\Float\FloatMaxExpression.cs" />
-    <Compile Include="Expressions\Float\FloatMinExpression.cs" />
-    <Compile Include="Expressions\Float\FloatEqualsExpression.cs" />
-    <Compile Include="Expressions\Float\FloatGreaterThanExpression.cs" />
-    <Compile Include="Expressions\Float\FloatSmallerThanExpression.cs" />
-    <Compile Include="Expressions\Float\FloatDefineExpression.cs" />
-    <Compile Include="Expressions\Float\FloatPopExpression.cs" />
-    <Compile Include="Expressions\Integer\IntegerPopExpression.cs" />
-    <Compile Include="Expressions\Integer\IntegerMinExpression.cs" />
-    <Compile Include="Expressions\Integer\IntegerMaxExpression.cs" />
-    <Compile Include="Expressions\Integer\IntegerDivideExpression.cs" />
-    <Compile Include="Expressions\Integer\IntegerDuplicateExpression.cs" />
-    <Compile Include="Expressions\Integer\IntegerEqualsExpression.cs" />
-    <Compile Include="Expressions\Integer\IntegerSmallerThanExpression.cs" />
-    <Compile Include="Expressions\Integer\IntegerGreaterThanExpression.cs" />
-    <Compile Include="Expressions\Integer\IntegerDefineExpression.cs" />
-    <Compile Include="Expressions\Integer\IntegerSubtractExpression.cs" />
-    <Compile Include="Expressions\Integer\IntegerAddExpression.cs" />
-    <Compile Include="Expressions\Integer\IntegerMultiplyExpression.cs" />
     <Compile Include="Expressions\Integer\IntegerPushExpression.cs" />
-    <Compile Include="Expressions\Name\NamePopExpression.cs" />
-    <Compile Include="Expressions\Name\NamePushExpression.cs" />
-    <Compile Include="Expressions\Name\NameDuplicateExpression.cs" />
     <Compile Include="Expressions\Name\NameDefineXExecExpression.cs" />
+    <Compile Include="Expressions\Templates\DefineExpressionTemplate.cs" />
+    <Compile Include="Expressions\Templates\DuplicateExpressionTemplate.cs" />
+    <Compile Include="Expressions\Templates\ExpressionTemplate.cs" />
+    <Compile Include="Expressions\Templates\PopExpressionTemplate.cs" />
+    <Compile Include="Expressions\Templates\PushResultExpressionTemplate.cs" />
+    <Compile Include="Interpreter\Configuration.cs" />
     <Compile Include="Generators\CodeGenerator.cs" />
     <Compile Include="Generators\Configuration.cs" />
-    <Compile Include="InstructionSets\ExecInstructionSet.cs" />
-    <Compile Include="InstructionSets\CodeInstructionSet.cs" />
-    <Compile Include="InstructionSets\FloatInstructionSet.cs" />
-    <Compile Include="InstructionSets\NameInstructionSet.cs" />
-    <Compile Include="InstructionSets\IntegerInstructionSet.cs" />
-    <Compile Include="InstructionSets\CommonInstructionSet.cs" />
-    <Compile Include="InstructionSets\BooleanInstructionSet.cs" />
     <Compile Include="OpCode.cs" />
     <Compile Include="OpCodeExtensions.cs" />
-    <Compile Include="OperationTable.cs" />
     <Compile Include="Parser\Parser.cs" />
-    <Compile Include="StaticRandom.cs" />
     <Compile Include="Stack\IStack.cs" />
     <Compile Include="Interpreter\Interpreter.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="Stack\IInterpreterService.cs" />
+    <Compile Include="Interpreter\IInterpreter.cs" />
     <Compile Include="Stack\PushGPStack.cs" />
     <Compile Include="Parser\SymbolTable.cs" />
+    <Compile Include="Symbols.cs" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj.user
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj.user	(revision 14328)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj.user	(revision 14328)
@@ -0,0 +1,6 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <ProjectView>ProjectFiles</ProjectView>
+  </PropertyGroup>
+</Project>
